package com.atlassian.confluence.jspwiki;

import com.atlassian.confluence.importexport.DefaultImportContext;
import com.atlassian.confluence.importexport.impl.AbstractImportExportTest;
import com.atlassian.confluence.license.LicenseFactory;
import com.atlassian.confluence.util.LicenseForTests;
import com.opensymphony.user.UserManager;

import java.io.File;

public class TestConfluenceExporter extends AbstractImportExportTest
{
    protected void setUp() throws Exception
    {
        super.setUp();

        UserManager um = new UserManager("osuser-test.xml");
        UserManager.setInstance(um);

        LicenseFactory.setUseMemoryStore(true);
        LicenseFactory.getLicenseManager().setLicense(LicenseForTests.EVALUATION);
    }

    protected void tearDown() throws Exception
    {
        LicenseFactory.setUseMemoryStore(false);
        UserManager.setInstance(null);
        super.tearDown();
    }

    public void testInstantiateManagers() throws Exception
    {
        ConfluenceExporter.instantiateManagers(new File("src/test/etc/jspwiki.properties"));
        assertNotNull(ConfluenceExporter.pageManager);
        assertNotNull(ConfluenceExporter.attachmentManager);
    }

    public void testExport() throws Exception
    {
        ConfluenceExporter.spaceName = "jspwiki";
        ConfluenceExporter.creatorUserName = "admin";
        String zipFileName = ConfluenceExporter.export(new File("src/test/etc/jspwiki.properties"));

        DefaultImportContext context = new DefaultImportContext(zipFileName);
        backupImporter.setContext(context);
        backupImporter.setSessionFactory(sessionFactory);
        backupImporter.setCacheManager(cacheManager);
        backupImporter.doImport();
    }
}
